'DDS-Generator - AD9851 - AD8321
'---------------------------------------------------

' es fehlt noch: Sweep-Modus, Offsets fr S/E, Bands, Men, RIT, LSB/USB


'MCUSR = &H80 besser fr M32: JTAG ber Fusebit deaktivieren
'MCUSR = &H80

$PROG &HFF , &HFF , &HD9,                                   'Lockbit + 2 Fusebits
                                      'damit ist JTAG deaktiviert !

$regfile = "m32def.dat"
$crystal = 4000000
$baud = 9600

$hwstack = 80
$swstack = 80
$framesize = 80

Config Lcdpin = Pin , Db4 = Portc.0 , Db5 = Portc.1 , Db6 = Portc.2 , Db7 = Portc.3 , E = Portc.5 , Rs = Portc.4
Config Lcd = 20 * 4


'fr Tastaturroutinen--------------------

Ddra = &H0F                                       '00001111 Ein- u. Ausgnge
Porta = &HF0                                      'Eing. mit PullUp, Ausg. auf 0

Ddrd.6 = 0
Portd.6 = 1                                       '5. Scan-Leitung fr 4 ext. Taster

Ddrd.3 = 0                                        '=INT1
Portd.3 = 1                                       'Eing. + PullUp

On Int1 Onint1
Mcucr.isc10 = 1                                   'INT1 bei FALLING + RISING
Mcucr.isc11 = 0                                   '=beim Drcken u. Loslassen einer Taste
Gimsk.int1 = 1

Dim Key As String * 1 : Key = ""
Dim Tastenarr As String * 20 : Tastenarr = "123CU456RV789FW-0+EX"


'fr Drehgeber---------------------------

Ddrd.2 = 0                                        'Eingnge mit Pullup fr Drehgeber
Portd.2 = 1

Ddrd.4 = 0
Portd.4 = 1

On Int0 Onint0
Mcucr.isc00 = 1                                   'INT0 bei FALLING + RISING
Mcucr.isc01 = 0
Gimsk.int0 = 1

Dim Drehgeber As Long                             'wird von ISR (INT0) verndert
Dim Drehgeber_alt As Long


'fr RS232-------------------------------

On Urxc Onrxd                                     'Interrupt-Routine setzen
Enable Urxc

Dim At_command As String * 16                     'AT FRQ=123456789
                                         'AT LEV=-127

'fr Anschlsse AD9851-------------------

Ddrb = &B11111011                                 'bis auf PB2 alles Ausgnge: AD8951+AD8321

9851_data Alias Portb.0
9851_clk Alias Portb.1
9851_fqud Alias Portb.3
9851_reset Alias Portb.4


'fr Anschlsse AD8321-------------------

8321_data Alias Portb.5
8321_clk Alias Portb.6
8321_ena Alias Portb.7

Ddrc = &B11111111                                 'Ausgnge: AD8321 + Display

Att32 Alias Portc.6
Att64 Alias Portc.7

Att32 = 0                                         'zunchst ohne Dmpfung
Att64 = 0


'fr 1000Hz-Ausgang---------------------

Ddrd.5 = 1                                        'OC1A-Ausgang-Buffer einschalten
Tccr1a.com1a0 = 1                                 'Toogle OC1A
Tccr1b.ctc1 = 1                                   'CTC-Modus (CLEAR TIMER ON COMPARE)
Ocr1ah = &H07                                     'zuerst HighByte
Ocr1al = &HD0


'---------------------------------------

Declare Sub Init
Declare Sub Show_frequ_anz(byval X As Integer , Byval Y As Integer)
Declare Sub Show_frequ_offset(byval X As Integer , Byval Y As Integer)
Declare Sub Show_entermode
Declare Sub Show_step(byval X As Integer , Byval Y As Integer)
Declare Sub Show_pegel_anz(byval X As Integer , Byval Y As Integer)
Declare Sub Calc_frequ_gen
Declare Sub Reset_ad9851
Declare Sub To_ad9851
Declare Sub To_ad8321(pegel As Integer)           'Dmpfung; -130..+10, Step: 0.7526 dB
Declare Sub Check_pegel_gen

Dim Frequ_anz As Long : Frequ_anz = 1000000       'als Defaultwerte
Dim Frequ_offset As Long : Frequ_offset = 0
Dim Frequ_gen As Long : Frequ_gen = Frequ_anz
Dim Frequ_step As Long : Frequ_step = 1000
Dim Ext_multi As Byte : Ext_multi = 1

Dim Frequ_anz_ee As Eram Long                     'frs EEPROM
Dim Frequ_offset_ee As Eram Long
Dim Frequ_step_ee As Eram Long
Dim Pegel_anz_ee As Eram Integer

Dim Pegel_anz As Integer : Pegel_anz = 0          '-130... + 10dbm
Dim Pegel_gen_akt As Integer                      ' (pseudo-) aktueller Pegel-Value

Dim Am As Byte : Am = 0                           'AM-Modulation 1000Hz ein/aus
Dim Entermode As Byte : Entermode = 0             '0: Frequ, 1: Offset, 2: Pegel
Dim Eingabe As String * 16

Dim L As Long

If Frequ_step_ee <> &HFFFFFFFF Then               'programmiert?
   Frequ_anz = Frequ_anz_ee                       'ja: dann aus EEPROM abrufen!
   Frequ_offset = Frequ_offset_ee
   Frequ_step = Frequ_step_ee
   Pegel_anz = Pegel_anz_ee
 End If

Sreg.7 = 1                                        'Interrupts freigeben
Cursor Off
Cursor Noblink

Cls
Lcd "DDS-Generator"
Locate 2 , 1
Lcd "10 Hz - 75 MHz"
Locate 3 , 1
Lcd "Vers. 1.0 22.06.2005";
Locate 4 , 1
Lcd "(c) by DiLi-Soft"

Waitms 2500
Reset_ad9851
Init

Drehgeber = Frequ_anz
Drehgeber_alt = Drehgeber
Do
   If Drehgeber <> Drehgeber_alt Then

      If Entermode = 0 Then
         L = Drehgeber - Drehgeber_alt
         L = L * Frequ_step
         Frequ_anz = Frequ_anz + L
         If Frequ_anz < 0 Then
            Frequ_anz = 0
         End If
         Drehgeber = Frequ_anz
         Drehgeber_alt = Drehgeber
         Call Show_frequ_anz(7 , 1)
         Calc_frequ_gen
         To_ad9851
         Eingabe = ""
      End If

      If Entermode = 1 Then
         L = Drehgeber - Drehgeber_alt
         L = L * Frequ_step
         Frequ_offset = Frequ_offset + L
         Drehgeber = Frequ_offset
         Drehgeber_alt = Drehgeber
         Call Show_frequ_offset(7 , 2)
         Calc_frequ_gen
         To_ad9851
         Eingabe = ""
      End If

      If Entermode = 2 Then
         L = Drehgeber - Drehgeber_alt
         Pegel_anz = Pegel_anz + L
         If Pegel_anz > 10 Then
            Pegel_anz = 10
         End If
         If Pegel_anz < -130 Then
            Pegel_anz = -130
         End If
         Drehgeber = Pegel_anz
         Drehgeber_alt = Drehgeber
         Call Show_pegel_anz(7 , 4)
         Call To_ad8321(pegel_anz)
         Eingabe = ""
      End If

      Waitms 50
   End If


   If At_command <> "" Then
      If Left(at_command , 3) = "AT " Then

         If Mid(at_command , 4 , 4) = "FRQ=" Then
            Eingabe = Mid(at_command , 8 , 9)
            Frequ_anz = Val(eingabe)
            Eingabe = ""
            Call Show_frequ_anz(7 , 1)
            Calc_frequ_gen
            To_ad9851
            Print " ok"
            Goto Atende
         End If

         If Mid(at_command , 4 , 4) = "OFF=" Then
            Eingabe = Mid(at_command , 8 , 9)
            Frequ_offset = Val(eingabe)
            Eingabe = ""
            Call Show_frequ_offset(7 , 2)
            Calc_frequ_gen
            To_ad9851
            Print " ok"
            Goto Atende
         End If

         If Mid(at_command , 4 , 4) = "LEV=" Then
            Eingabe = Mid(at_command , 8 , 9)
            Pegel_anz = Val(eingabe)
            Eingabe = ""
            Call Show_pegel_anz(7 , 4)
            Call To_ad8321(pegel_anz)
            Print " ok"
            Goto Atende
         End If

         If Mid(at_command , 4 , 4) = "EXT=" Then
            Eingabe = Mid(at_command , 8 , 9)
            Ext_multi = Val(eingabe)
            Calc_frequ_gen
            To_ad9851
            Eingabe = ""
            Print " ok"
            Goto Atende
         End If

         Print " unknown command"

      Else
         Print " unknown command"
      End If
      Atende:
      At_command = ""
   End If


   If Key <> "" Then
      Select Case Key

         Case "U" : If Eingabe = "" Then          'Taste 1: entermode toogeln
                       Incr Entermode
                       If Entermode = 3 Then
                          Entermode = 0
                       End If
                       Show_entermode
                    End If

         Case "V" : If Am = 0 Then                'Taste 2: AM ein/aus
                       Timer1 = 0
                       Tccr1b.cs10 = 1            'OnCompare einschalten; 1000Hz ein
                       Am = 1
                       Locate 3 , 19
                       Lcd "AM";
                    Else
                       Tccr1b.cs10 = 0            '1000Hz ausschalten
                       Am = 0
                       Locate 3 , 19
                       Lcd "  ";
                    End If

         Case "W" : If Eingabe = "" Then          'Taste 3: speichern
                       Cls
                       Locate 2 , 1
                       Lcd "Saving? (CE / E)"
                       Key = ""
                       While Key = ""
                       Wend
                       If Key = "E" Then
                          Locate 3 , 1
                          Lcd "saving...";
                          Sreg.7 = 0              'Interrupts aus
                          Frequ_anz_ee = Frequ_anz
                          Frequ_offset_ee = Frequ_offset
                          Frequ_step_ee = Frequ_step
                          Pegel_anz_ee = Pegel_anz
                          Sreg.7 = 1              'Ints wieder an
                          Waitms 100
                          Lcd " ok"
                          Waitms 500
                       End If
                       Init
                    End If

         Case "X" : If Eingabe = "" Then          'Taste 4: Speicherabruf
                       If Frequ_step_ee <> &HFFFFFFFF Then       'programmiert?
                          Cls
                          Locate 2 , 1
                          Lcd "Restore? (CE / E)"
                          Key = ""
                          While Key = ""
                          Wend
                          If Key = "E" Then
                             Sreg.7 = 0
                             Frequ_anz = Frequ_anz_ee
                             Frequ_offset = Frequ_offset_ee
                             Frequ_step = Frequ_step_ee
                             Pegel_anz = Pegel_anz_ee
                             Sreg.7 = 1
                             Entermode = 0
                          End If
                          Init
                       End If
                    End If

         Case "C" : Eingabe = ""                  'CE-Taste
                     Select Case Entermode
                        Case 0 : Call Show_frequ_anz(7 , 1)

                        Case 1 : Call Show_frequ_offset(7 , 2)

                        Case 2 : Call Show_pegel_anz(7 , 4)
                     End Select

         Case "R" : L = Frequ_anz \ Frequ_step    'genau aufs Raster setzen
                    Frequ_anz = L * Frequ_step
                    Call Show_frequ_anz(7 , 1)
                    Calc_frequ_gen
                    To_ad9851

         Case "F" : Print "F-Key"                 'noch unbelegt

         Case "E" : If Eingabe <> "" Then         'Eingabe abschlieen
                        Select Case Entermode
                           Case 0 : Frequ_anz = Val(eingabe)
                                    Frequ_anz = Frequ_anz * 1000
                                    Eingabe = ""
                                    Call Show_frequ_anz(7 , 1)
                                    Calc_frequ_gen
                                    To_ad9851

                           Case 1 : Frequ_offset = Val(eingabe)
                                    Eingabe = ""
                                    Call Show_frequ_offset(7 , 2)
                                    Calc_frequ_gen
                                    To_ad9851

                           Case 2 : Pegel_anz = Val(eingabe)
                                    If Pegel_anz > 10 Then
                                       Pegel_anz = 10
                                    End If
                                    If Pegel_anz < -130 Then
                                       Pegel_anz = -130
                                    End If
                                    Eingabe = ""
                                    Call Show_pegel_anz(7 , 4)
                                    Call To_ad8321(pegel_anz)

                        End Select
                        Show_entermode
                    End If

         Case "0" To "9" : Select Case Entermode
                               Case 0 : If Len(eingabe) < 6 Then
                                            Eingabe = Eingabe + Key
                                            Locate 1 , 7
                                            Lcd Spc(11) ; "k";
                                            Locate 1 , 7
                                            Lcd Eingabe;
                                         End If

                               Case 1 : If Len(eingabe) < 8 Then
                                            Eingabe = Eingabe + Key
                                            Locate 2 , 7
                                            Lcd Spc(11);
                                            Locate 2 , 7
                                            Lcd Eingabe;
                                         Else
                                            If Len(eingabe) < 9 Then
                                               If Left(eingabe , 1) = "-" Then
                                                  Eingabe = Eingabe + Key
                                                  Locate 2 , 7
                                                  Lcd Spc(11);
                                                  Locate 2 , 7
                                                  Lcd Eingabe;
                                               End If
                                            End If
                                         End If

                               Case 2 : If Len(eingabe) < 3 Then
                                            Eingabe = Eingabe + Key
                                            Locate 4 , 7
                                            Lcd Spc(14);
                                            Locate 4 , 7
                                            Lcd Eingabe;
                                         Else
                                            If Len(eingabe) < 4 Then
                                               If Left(eingabe , 1) = "-" Then
                                                  Eingabe = Eingabe + Key
                                                  Locate 4 , 7
                                                  Lcd Spc(14);
                                                  Locate 4 , 7
                                                  Lcd Eingabe;
                                               End If
                                            End If
                                         End If
                            End Select

         Case "+" : If Entermode = 0 Then
                        Select Case Frequ_step
                          Case 1 : Frequ_step = 10
                          Case 10 : Frequ_step = 100
                          Case 100 : Frequ_step = 1000
                          Case 1000 : Frequ_step = 5000
                          Case 5000 : Frequ_step = 9000
                          Case 9000 : Frequ_step = 10000
                          Case 10000 : Frequ_step = 12500
                          Case 12500 : Frequ_step = 25000
                          Case 25000 : Frequ_step = 50000
                          Case 50000 : Frequ_step = 100000
                          Case 100000 : Frequ_step = 1000000
                          Case 1000000 : Frequ_step = 10000000
                          Case 10000000 : Frequ_step = 1
                        End Select
                        Call Show_step(7 , 3)
                    End If

         Case "-" : Select Case Entermode
                       Case 0 : Select Case Frequ_step
                                    Case 1 : Frequ_step = 10000000
                                    Case 10 : Frequ_step = 1
                                    Case 100 : Frequ_step = 10
                                    Case 1000 : Frequ_step = 100
                                    Case 5000 : Frequ_step = 1000
                                    Case 9000 : Frequ_step = 5000
                                    Case 10000 : Frequ_step = 9000
                                    Case 12500 : Frequ_step = 10000
                                    Case 25000 : Frequ_step = 12500
                                    Case 50000 : Frequ_step = 25000
                                    Case 100000 : Frequ_step = 50000
                                    Case 1000000 : Frequ_step = 100000
                                    Case 10000000 : Frequ_step = 1000000
                                 End Select
                                 Call Show_step(7 , 3)

                       Case 1 : If Len(eingabe) = 0 Then       ' - am Anfang v. Offset
                                    Eingabe = Key
                                    Locate 2 , 7
                                    Lcd Spc(11);
                                    Locate 2 , 7
                                    Lcd Eingabe;
                                 End If

                       Case 2 : If Len(eingabe) = 0 Then       ' - am Anfang v. Offset
                                    Eingabe = Key
                                    Locate 4 , 7
                                    Lcd Spc(14);
                                    Locate 4 , 7
                                    Lcd Eingabe;
                                 End If
                     End Select
      End Select

      Key = ""                                    'damit ist Taste abgeholt
   End If                                         'if key <> ""
Loop

End


'----------------------------------------

Sub Init
   Cls

   Lcd "Frqu:";
   Call Show_frequ_anz(7 , 1)
   Calc_frequ_gen
   To_ad9851

   Locate 2 , 1
   Lcd "Offs:";
   Call Show_frequ_offset(7 , 2)

   Locate 3 , 1
   Lcd "Step:";
   Call Show_step(7 , 3)

   Locate 3 , 19
   If Am = 1 Then
      Lcd "AM";
   Else
      Lcd "  ";
   End If

   Locate 4 , 1
   Lcd "Pout:" ;
   Call Show_pegel_anz(7 , 4)
   Call To_ad8321(pegel_anz)

   Show_entermode
End Sub


'Anzeige-Routinen-------------------------

Sub Show_frequ_anz(byval X As Integer , Byval Y As Integer)
   Local S2 As String * 11
   Local S As String * 9

   Locate Y , X
   S = Str(frequ_anz)
   S = Format(s , "000000000")
   S2 = Left(s , 3) + "." + Mid(s , 4 , 3) + "." + Right(s , 3)
   Lcd S2 ; " Hz";
End Sub


Sub Show_frequ_offset(byval X As Integer , Byval Y As Integer)
   Local S2 As String * 11
   Local S As String * 9

   Locate Y , X
   S = Str(frequ_offset)
   S = Format(s , "+00000000")
   S2 = Left(s , 3) + "." + Mid(s , 4 , 3) + "." + Right(s , 3)
   Lcd S2 ; " Hz";
End Sub


Sub Show_entermode
   Select Case Entermode
      Case 0 : Locate 2 , 6
                Lcd " ";
                Locate 4 , 6
                Lcd " ";

      Case 1 : Locate 2 , 6
                Lcd "*";
                Locate 4 , 6
                Lcd " ";

      Case 2 : Locate 2 , 6
                Lcd " ";
                Locate 4 , 6
                Lcd "*";
   End Select
End Sub


Sub Show_step(byval X As Integer , Byval Y As Integer)
   Locate Y , X
   Select Case Frequ_step
      Case 1 : Lcd "   1  ";
      Case 10 : Lcd "  10  ";
      Case 100 : Lcd " 100  ";
      Case 1000 : Lcd "   1 k";
      Case 5000 : Lcd "   5 k";
      Case 9000 : Lcd "   9 k";
      Case 10000 : Lcd "  10 k";
      Case 12500 : Lcd "12,5 k";
      Case 25000 : Lcd "  25 k";
      Case 50000 : Lcd "  50 k";
      Case 100000 : Lcd " 100 k";
      Case 1000000 : Lcd "   1 M";
      Case 10000000 : Lcd "  10 M";
   End Select
   Lcd "Hz";
End Sub


Sub Show_pegel_anz(byval X As Integer , Byval Y As Integer)
   Local S As String * 4
   Local I As Integer
   Local Si As Single
   Local Einh As String * 2

   Locate Y , X
   Lcd Spc(14);
   Locate Y , X

   I = Pegel_anz
   S = Str(i)
   Lcd S ; "dBm =" ;

   I = I + 107                                    'dBm -> dBuV
   Si = I
   Si = Si / 20
   Si = 10 ^ Si                                   'dBuV-> uV

   If Si < 1000 Then
      Einh = "uV"
   Else
      Einh = "mV"
      Si = Si / 1000
   End If

   If Si < 10 Then
      S = Fusing(si , "#.#")
   Else
      Si = Round(si)
      I = Si
      S = Str(i)
   End If

   Lcd S ; Einh;
End Sub


Sub Calc_frequ_gen
   Frequ_gen = Frequ_anz + Frequ_offset
   Frequ_gen = Frequ_gen / Ext_multi
End Sub


'Generator-Routinen---------------------

Sub Reset_ad9851
   9851_reset = 0                                 'Ausgangslage
   9851_clk = 0
   9851_fqud = 0
   Waitus 1

   9851_reset = 1                                 'RESET
   Waitus 1
   9851_reset = 0
   Waitms 1

   9851_clk = 1                                   'Clock bernimmt parallele Daten
   Waitus 1                                       'dort muss xxxxx011 anliegen !!!
   9851_clk = 0
   Waitus 1

   9851_fqud = 1                                  'Umschaltung auf Seriell-Mode
   Waitus 1
   9851_fqud = 0
   Waitus 1
End Sub


Dim Frequ_gen_d As Double                         'geht zurzeit nur global !

Sub To_ad9851
  'Local frequ_gen_d as Double                               'liefert Fehler
   Local W As Long
   Local Lauf As Byte

   Frequ_gen_d = Frequ_gen
   Frequ_gen_d = Frequ_gen_d * 23.8609294222222222222222       '= 2 ^ 32 / 180MHz; = delta phi pro Hz
   Frequ_gen_d = Round(frequ_gen_d)
   W = Frequ_gen_d
   'print W

   For Lauf = 1 To 32
      9851_data = W.0
      Waitus 1

      9851_clk = 1                                'Clock
      Waitus 1
      9851_clk = 0
      Waitus 1

      Shift W , Right , 1                         'von LSB nach MSB (W0 bis W31)
   Next Lauf

   W = &B00000001                                 'W32 bis W39; hier wird nur 6x REFCLOCK gesetzt
   For Lauf = 1 To 8
      9851_data = W.0
      Waitus 1

      9851_clk = 1                                'Clock
      Waitus 1
      9851_clk = 0
      Waitus 1

      Shift W , Right , 1
   Next Lauf

   9851_fqud = 1                                  'FQ_UD bernimmt die 40 Bit
   Waitus 1
   9851_fqud = 0

   Check_pegel_gen                                'ggf. Pegel anpassen
End Sub


Sub To_ad8321(pegel As Integer)                   'att(enuator) von -130...+10dBm
   Local Att_byte As Byte
   Local Lauf As Byte
   Local Si As Single

   Si = Pegel / 0.7526
   Si = 51 + Si

   Select Case Frequ_gen
     'case is < 36000000:
      Case 36000001 To 57000000 : Si = Si + 1     'sin(x)/x + Filter ausgleichen
      Case 57000001 To 66500000 : Si = Si + 2
      Case 66500001 To 70500000 : Si = Si + 3
      Case 70500001 To 73500000 : Si = Si + 4
      Case 73500001 To 75000000 : Si = Si + 5
      Case Is > 75000000 : Si = -121              '=-130dBm
   End Select

   Pegel_gen_akt = Round(si)                      'zum Vergleich, wenn Frequ.-nderung
   Lauf = 0
   While Si < 5.82                                '=-34dBm; das schafft der AD8321 allein
      Si = Si + 42.5193                           '= +32dB
      Incr Lauf
   Wend

   Select Case Lauf
      Case 0 : Att32 = 0                          'Dmpfungsglieder entspr. einstellen
               Att64 = 0

      Case 1 : Att32 = 1
               Att64 = 0

      Case 2 : Att32 = 0
               Att64 = 1

      Case 3 : Att32 = 1
               Att64 = 1
   End Select

   Si = Round(si)
   Att_byte = Int(si)

   8321_ena = 0                                   'zunchst auf 0
   8321_clk = 0
   Waitus 1

   For Lauf = 1 To 8
      8321_data = Att_byte.7                      'hier von MSB nach LSB !!
      Waitus 1
      8321_clk = 1
      Waitus 1
      8321_clk = 0

      Shift Att_byte , Left , 1
   Next Lauf

   Waitus 1
   8321_ena = 1                                   'damit wird bernommen
End Sub


Sub Check_pegel_gen
   Local Si As Single
   Local I As Integer

   Si = Pegel_anz / 0.7526
   Si = 51 + Si
   Select Case Frequ_gen
     'case is < 36000000:
      Case 36000001 To 57000000 : Si = Si + 1     'sin(x)/x + Filter ausgleichen
      Case 57000001 To 66500000 : Si = Si + 2
      Case 66500001 To 70500000 : Si = Si + 3
      Case 70500001 To 73500000 : Si = Si + 4
      Case 73500001 To 75000000 : Si = Si + 5
      Case Is > 75000000 : Si = -121
   End Select
   I = Round(si)
   If I <> Pegel_gen_akt Then
      Call To_ad8321(pegel_anz)
      Pegel_gen_akt = I
   End If

End Sub


'Tastaturroutine-------------------------
'Rckgaben:
'var key = letztes Zeichen

Dim Zeile As Byte
Dim Spalte As Byte
Dim Scancode As Byte

Onint1:
   If Key <> "" Then                              'Taste noch nicht ausgewertet
      Goto Keyende
   End If

   Waitms 10                                      'Tastenpreller abwarten
   If Pind.3 = 0 Then                             '=INT1; Taste gedrckt
      Porta = Pina Or &H0F                        'zunchst alle Zeilen auf 1
      For Zeile = 0 To 3
         Porta.zeile = 0                          'dann Zeilen 0..3 einzeln auf 0

         For Spalte = 4 To 7                      'damit die Spalten durchsuchen
            If Pina.spalte = 0 Then               'Taste gefunden
               Scancode = Zeile * 5
               Scancode = Scancode + Spalte
               Scancode = Scancode - 3            '1..4, 6..9, 11..14, 16..19
               Goto Keyende                       'Taste merken; wird beim Loslassen aktiv
            End If
         Next Spalte

         If Pind.6 = 0 Then                       'externe Tasten (Spalte 5)
            Scancode = Zeile * 5                  '5,10,15,20
            Scancode = Scancode + 5
            Goto Keyende
         End If

         Porta.zeile = 1                          'akt. Zeile auf 1 zurck
      Next Zeile
   Else                                           'Taste los gelassen
      If Scancode > 0 Then
         Key = Mid(tastenarr , Scancode , 1)
         Scancode = 0
      End If
   End If

   Keyende:
   Porta = &HF0                                   'Start-Scannzustand wiederherstellen
   Gifr.intf1 = 1                                 'ggf. Tastenpreller entfernen
Return


'Drehgeber-Routine-----------------------
'verndert var drehgeber (=long)

Drehimpuls1 Alias Pind.2
Drehimpuls2 Alias Pind.4
Onint0:
   If Drehimpuls1 = 1 Then                        'steigende Flanke
      If Drehimpuls2 = 1 Then
         Decr Drehgeber
      Else
         Incr Drehgeber
      End If
   Else                                           'fallende Flanke
      If Drehimpuls2 = 0 Then
         Decr Drehgeber
      Else
         Incr Drehgeber
      End If
   End If
   Waitus 50
   Gifr.intf0 = 1                                 'evtl. Preller entfernen
Return


'RS232-Empfangsroutine------------------

Dim Ser_buf As String * 16
Dim Udr_buf As Byte

Onrxd:
   Udr_buf = Udr                                  'Byte aus der UART auslesen
   If Udr_buf <> 13 Then
      If Udr_buf <> 8 Then
         If Len(ser_buf) < 16 Then
            Ser_buf = Ser_buf + Chr(udr_buf)
            Udr = Udr_buf                         'Echo auf Konsole
         End If
      End If
   Else
      At_command = Ser_buf                        'erst nach CR bergeben
      Ser_buf = ""
   End If
Return




